//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "StatPlusUnit.h"
//----------------------------------------------------------------------------//
#pragma package(smart_init)
#pragma link "LMDBaseControl"
#pragma link "LMDBaseGraphicControl"
#pragma link "LMDBaseMeter"
#pragma link "LMDControl"
#pragma link "LMDCustomProgress"
#pragma link "LMDGraphicControl"
#pragma link "LMDProgress"
#pragma link "LMDCustomComponent"
#pragma link "LMDOneInstance"
#pragma resource "*.dfm"
TFormStatPlus *FormStatPlus;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Select KeyCode
// get the keycode from a "code string"
//
unsigned int SelectKeyCode(char *szSearch)
{

        unsigned int vKey;

        if(stricmp(szSearch,"LBUTTON") == 0 ) {
                vKey = 0x01 ; // 'Left mouse button
                return vKey;
        }
        if(stricmp(szSearch,"RBUTTON") == 0 ) {
                vKey = 0x02 ; // 'Right mouse button
                return vKey;
        }
        if(stricmp(szSearch,"CANCEL") == 0 ) {
                vKey = 0x03 ; // 'Control-break processing
                return vKey;
        }
        if(stricmp(szSearch,"MBUTTON") == 0 ) {
                vKey = 0x04 ; // 'Middle mouse button (three-button mouse)
                return vKey;
        }
        if(stricmp(szSearch,"XBUTTON1") == 0 ) {
                vKey = 0x05 ; // 'Windows 2000: X1 mouse button
                return vKey;
        }
        if(stricmp(szSearch,"XBUTTON2") == 0 ) {
                vKey = 0x06 ; // 'Windows 2000: X2 mouse button
                return vKey;
        }
        if(stricmp(szSearch,"BACK") == 0 ) {
                vKey = 0x08 ; // 'BACKSPACE key
                return vKey;
        }
        if(stricmp(szSearch,"TAB") == 0 ) {
                vKey = 0x09 ; // 'TAB key
                return vKey;
        }
        if(stricmp(szSearch,"CLEAR") == 0 ) {
                vKey = 0x0C ; // 'CLEAR key
                return vKey;
        }
        if(stricmp(szSearch,"RETURN") == 0 ) {
                vKey = 0x0D ; // 'ENTER key
                return vKey;
        }
        if(stricmp(szSearch,"SHIFT") == 0 ) {
                vKey = 0x010; // 'SHIFT key
                return vKey;
        }
        if(stricmp(szSearch,"CONTROL") == 0 ) {
                vKey = 0x011; // 'CTRL key
                return vKey;
        }
        if(stricmp(szSearch,"MENU") == 0 ) {
                vKey = 0x012; // 'ALT key
                return vKey;
        }
        if(stricmp(szSearch,"PAUSE") == 0 ) {
                vKey = 0x013; // 'PAUSE key
                return vKey;
        }
        if(stricmp(szSearch,"CAPITAL") == 0 ) {
                vKey = 0x014; // 'CAPS LOCK key
                return vKey;
        }
        if(stricmp(szSearch,"KANA") == 0 ) {
                vKey = 0x015; // 'IME Kana mode
                return vKey;
        }
        if(stricmp(szSearch,"HANGUL") == 0 ) {
                vKey = 0x015; // 'IME Hangul mode
                return vKey;
        }
        if(stricmp(szSearch,"JUNJA") == 0 ) {
                vKey = 0x017; // 'IME Junja mode
                return vKey;
        }
        if(stricmp(szSearch,"FINAL") == 0 ) {
                vKey = 0x018; // 'IME final mode
                return vKey;
        }
        if(stricmp(szSearch,"HANJA") == 0 ) {
                vKey = 0x019; // 'IME Hanja mode
                return vKey;
        }
        if(stricmp(szSearch,"KANJI") == 0 ) {
                vKey = 0x019; // 'IME Kanji mode
                return vKey;
        }
        if(stricmp(szSearch,"ESCAPE") == 0 ) {
                vKey = 0x01B; // 'ESC key
                return vKey;
        }
        if(stricmp(szSearch,"CONVERT") == 0 ) {
                vKey = 0x01C; // 'IME convert
                return vKey;
        }
        if(stricmp(szSearch,"NONCONVERT") == 0 ) {
                vKey = 0x01D; // 'IME nonconvert
                return vKey;
        }
        if(stricmp(szSearch,"ACCEPT") == 0 ) {
                vKey = 0x01E; // 'IME accept
                return vKey;
        }
        if(stricmp(szSearch,"MODECHANGE") == 0 ) {
                vKey = 0x01F; // 'IME mode change request
                return vKey;
        }
        if(stricmp(szSearch,"SPACE") == 0 ) {
                vKey = 0x020; // 'SPACEBAR
                return vKey;
        }
        if(stricmp(szSearch,"PRIOR") == 0 ) {
                vKey = 0x021; // 'PAGE UP key
                return vKey;
        }
        if(stricmp(szSearch,"NEXT") == 0 ) {
                vKey = 0x022; // 'PAGE DOWN key
                return vKey;
        }
        if(stricmp(szSearch,"END") == 0 ) {
                vKey = 0x023; // 'END key
                return vKey;
        }
        if(stricmp(szSearch,"HOME") == 0 ) {
                vKey = 0x024; // 'HOME key
                return vKey;
        }
        if(stricmp(szSearch,"LEFT") == 0 ) {
                vKey = 0x025; // 'LEFT ARROW key
                return vKey;
        }
        if(stricmp(szSearch,"UP") == 0 ) {
                vKey = 0x026; // 'UP ARROW key
                return vKey;
        }
        if(stricmp(szSearch,"RIGHT") == 0 ) {
                vKey = 0x027; // 'RIGHT ARROW key
                return vKey;
        }
        if(stricmp(szSearch,"DOWN") == 0 ) {
                vKey = 0x028; // 'DOWN ARROW key
                return vKey;
        }
        if(stricmp(szSearch,"SELECT") == 0 ) {
                vKey = 0x029; // 'SELECT key
                return vKey;
        }
        if(stricmp(szSearch,"PRINT") == 0 ) {
                vKey = 0x02A; // 'PRINT key
                return vKey;
        }
        if(stricmp(szSearch,"EXECUTE") == 0 ) {
                vKey = 0x02B; // 'EXECUTE key
                return vKey;
        }
        if(stricmp(szSearch,"SNAPSHOT") == 0 ) {
                vKey = 0x02C; // 'PRINT SCREEN key
                return vKey;
        }
        if(stricmp(szSearch,"INSERT") == 0 ) {
                vKey = 0x02D; // 'INS key
                return vKey;
        }
        if(stricmp(szSearch,"DELETE") == 0 ) {
                vKey = 0x02E; // 'DEL key
                return vKey;
        }
        if(stricmp(szSearch,"HELP") == 0 ) {
                vKey = 0x02F; // 'HELP key
                return vKey;
        }
        if(stricmp(szSearch,"0") == 0 ) {
                vKey = 0x030; // '0 key
                return vKey;
        }
        if(stricmp(szSearch,"1") == 0 ) {
                vKey = 0x031; // '1 key
                return vKey;
        }
        if(stricmp(szSearch,"2") == 0 ) {
                vKey = 0x032; // '2 key
                return vKey;
        }
        if(stricmp(szSearch,"3") == 0 ) {
                vKey = 0x033; // '3 key
                return vKey;
        }
        if(stricmp(szSearch,"4") == 0 ) {
                vKey = 0x034; // '4 key
                return vKey;
        }
        if(stricmp(szSearch,"5") == 0 ) {
                vKey = 0x035; // '5 key
                return vKey;
        }
        if(stricmp(szSearch,"6") == 0 ) {
                vKey = 0x036; // '6 key
                return vKey;
        }
        if(stricmp(szSearch,"7") == 0 ) {
                vKey = 0x037; // '7 key
                return vKey;
        }
        if(stricmp(szSearch,"8") == 0 ) {
                vKey = 0x038; // '8 key
                return vKey;
        }
        if(stricmp(szSearch,"9") == 0 ) {
                vKey = 0x039; // '9 key
                return vKey;
        }
        if(stricmp(szSearch,"A") == 0 ) {
                vKey = 0x041; // 'A key
                return vKey;
        }
        if(stricmp(szSearch,"B") == 0 ) {
                vKey = 0x042; // 'B key
                return vKey;
        }
        if(stricmp(szSearch,"C") == 0 ) {
                vKey = 0x043; // 'C key
                return vKey;
        }
        if(stricmp(szSearch,"D") == 0 ) {
                vKey = 0x044; // 'D key
                return vKey;
        }
        if(stricmp(szSearch,"E") == 0 ) {
                vKey = 0x045; // 'E key
                return vKey;
        }
        if(stricmp(szSearch,"F") == 0 ) {
                vKey = 0x046; // 'F key
                return vKey;
        }
        if(stricmp(szSearch,"G") == 0 ) {
                vKey = 0x047; // 'G key
                return vKey;
        }
        if(stricmp(szSearch,"H") == 0 ) {
                vKey = 0x048; // 'H key
                return vKey;
        }
        if(stricmp(szSearch,"I") == 0 ) {
                vKey = 0x049; // 'I key
                return vKey;
        }
        if(stricmp(szSearch,"J") == 0 ) {
                vKey = 0x04A; // 'J key
                return vKey;
        }
        if(stricmp(szSearch,"K") == 0 ) {
                vKey = 0x04B; // 'K key
                return vKey;
        }
        if(stricmp(szSearch,"L") == 0 ) {
                vKey = 0x04C; // 'L key
                return vKey;
        }
        if(stricmp(szSearch,"M") == 0 ) {
                vKey = 0x04D; // 'M key
                return vKey;
        }
        if(stricmp(szSearch,"N") == 0 ) {
                vKey = 0x04E; // 'N key
                return vKey;
        }
        if(stricmp(szSearch,"O") == 0 ) {
                vKey = 0x04F; // 'O key
                return vKey;
        }
        if(stricmp(szSearch,"P") == 0 ) {
                vKey = 0x050; // 'P key
                return vKey;
        }
        if(stricmp(szSearch,"Q") == 0 ) {
                vKey = 0x051; // 'Q key
                return vKey;
        }
        if(stricmp(szSearch,"R") == 0 ) {
                vKey = 0x052; // 'R key
                return vKey;
        }
        if(stricmp(szSearch,"S") == 0 ) {
                vKey = 0x053; // 'S key
                return vKey;
        }
        if(stricmp(szSearch,"T") == 0 ) {
                vKey = 0x054; // 'T key
                return vKey;
        }
        if(stricmp(szSearch,"U") == 0 ) {
                vKey = 0x055; // 'U key
                return vKey;
        }
        if(stricmp(szSearch,"V") == 0 ) {
                vKey = 0x056; // 'V key
                return vKey;
        }
        if(stricmp(szSearch,"W") == 0 ) {
                vKey = 0x057; // 'W key
                return vKey;
        }
        if(stricmp(szSearch,"X") == 0 ) {
                vKey = 0x058; // 'X key
                return vKey;
        }
        if(stricmp(szSearch,"Y") == 0 ) {
                vKey = 0x059; // 'Y key
                return vKey;
        }
        if(stricmp(szSearch,"Z") == 0 ) {
                vKey = 0x05A; // 'Z key
                return vKey;
        }
        if(stricmp(szSearch,"LWIN") == 0 ) {
                vKey = 0x05B; // 'Left Windows key (Microsoft Natural keyboard)
                return vKey;
        }
        if(stricmp(szSearch,"RWIN") == 0 ) {
                vKey = 0x05C; // 'Right Windows key (Natural keyboard)
                return vKey;
        }
        if(stricmp(szSearch,"APPS") == 0 ) {
                vKey = 0x05D; // 'Applications key (Natural keyboard)
                return vKey;
        }
        if(stricmp(szSearch,"SLEEP") == 0 ) {
                vKey = 0x05F; // 'Computer Sleep key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD0") == 0 ) {
                vKey = 0x060; // 'Numeric keypad 0 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD1") == 0 ) {
                vKey = 0x061; // 'Numeric keypad 1 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD2") == 0 ) {
                vKey = 0x062; // 'Numeric keypad 2 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD3") == 0 ) {
                vKey = 0x063; // 'Numeric keypad 3 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD4") == 0 ) {
                vKey = 0x064; // 'Numeric keypad 4 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD5") == 0 ) {
                vKey = 0x065; // 'Numeric keypad 5 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD6") == 0 ) {
                vKey = 0x066; // 'Numeric keypad 6 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD7") == 0 ) {
                vKey = 0x067; // 'Numeric keypad 7 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD8") == 0 ) {
                vKey = 0x068; // 'Numeric keypad 8 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMPAD9") == 0 ) {
                vKey = 0x069; // 'Numeric keypad 9 key
                return vKey;
        }
        if(stricmp(szSearch,"MULTIPLY") == 0 ) {
                vKey = 0x06A; // 'Multiply key
                return vKey;
        }
        if(stricmp(szSearch,"ADD") == 0 ) {
                vKey = 0x06B; // 'Add key
                return vKey;
        }
        if(stricmp(szSearch,"SEPARATOR") == 0 ) {
                vKey = 0x06C; // 'Separator key
                return vKey;
        }
        if(stricmp(szSearch,"SUBTRACT") == 0 ) {
                vKey = 0x06D; // 'Subtract key
                return vKey;
        }
        if(stricmp(szSearch,"DECIMAL") == 0 ) {
                vKey = 0x06E; // 'Decimal key
                return vKey;
        }
        if(stricmp(szSearch,"DIVIDE") == 0 ) {
                vKey = 0x06F; // 'Divide key
                return vKey;
        }
        if(stricmp(szSearch,"F1") == 0 ) {
                vKey = 0x070; // 'F1 key
                return vKey;
        }
        if(stricmp(szSearch,"F2") == 0 ) {
                vKey = 0x071; // 'F2 key
                return vKey;
        }
        if(stricmp(szSearch,"F3") == 0 ) {
                vKey = 0x072; // 'F3 key
                return vKey;
        }
        if(stricmp(szSearch,"F4") == 0 ) {
                vKey = 0x073; // 'F4 key
                return vKey;
        }
        if(stricmp(szSearch,"F5") == 0 ) {
                vKey = 0x074; // 'F5 key
                return vKey;
        }
        if(stricmp(szSearch,"F6") == 0 ) {
                vKey = 0x075; // 'F6 key
                return vKey;
        }
        if(stricmp(szSearch,"F7") == 0 ) {
                vKey = 0x076; // 'F7 key
                return vKey;
        }
        if(stricmp(szSearch,"F8") == 0 ) {
                vKey = 0x077; // 'F8 key
                return vKey;
        }
        if(stricmp(szSearch,"F9") == 0 ) {
                vKey = 0x078; // 'F9 key
                return vKey;
        }
        if(stricmp(szSearch,"F10") == 0 ) {
                vKey = 0x079; // 'F10 key
                return vKey;
        }
        if(stricmp(szSearch,"F11") == 0 ) {
                vKey = 0x07A; // 'F11 key
                return vKey;
        }
        if(stricmp(szSearch,"F12") == 0 ) {
                vKey = 0x07B; // 'F12 key
                return vKey;
        }
        if(stricmp(szSearch,"F13") == 0 ) {
                vKey = 0x07C; // 'F13 key
                return vKey;
        }
        if(stricmp(szSearch,"F14") == 0 ) {
                vKey = 0x07D; // 'F14 key
                return vKey;
        }
        if(stricmp(szSearch,"F15") == 0 ) {
                vKey = 0x07E; // 'F15 key
                return vKey;
        }
        if(stricmp(szSearch,"F16") == 0 ) {
                vKey = 0x07F; // 'F16 key
                return vKey;
        }
        if(stricmp(szSearch,"F17") == 0 ) {
                vKey = 0x080; // 'F17 key
                return vKey;
        }
        if(stricmp(szSearch,"F18") == 0 ) {
                vKey = 0x081; // 'F18 key
                return vKey;
        }
        if(stricmp(szSearch,"F19") == 0 ) {
                vKey = 0x082; // 'F19 key
                return vKey;
        }
        if(stricmp(szSearch,"F20") == 0 ) {
                vKey = 0x083; // 'F20 key
                return vKey;
        }
        if(stricmp(szSearch,"F21") == 0 ) {
                vKey = 0x084; // 'F21 key
                return vKey;
        }
        if(stricmp(szSearch,"F22") == 0 ) {
                vKey = 0x085; // 'F22 key
                return vKey;
        }
        if(stricmp(szSearch,"F23") == 0 ) {
                vKey = 0x086; // 'F23 key
                return vKey;
        }
        if(stricmp(szSearch,"F24") == 0 ) {
                vKey = 0x087; // 'F24 key
                return vKey;
        }
        if(stricmp(szSearch,"NUMLOCK") == 0 ) {
                vKey = 0x090; // 'NUM LOCK key
                return vKey;
        }
        if(stricmp(szSearch,"SCROLL") == 0 ) {
                vKey = 0x091; // 'SCROLL LOCK key
                return vKey;
        }
        if(stricmp(szSearch,"LSHIFT") == 0 ) {
                vKey = 0x0A0; // 'Left SHIFT key
                return vKey;
        }
        if(stricmp(szSearch,"RSHIFT") == 0 ) {
                vKey = 0x0A1; // 'Right SHIFT key
                return vKey;
        }
        if(stricmp(szSearch,"LCONTROL") == 0 ) {
                vKey = 0x0A2; // 'Left CONTROL key
                return vKey;
        }
        if(stricmp(szSearch,"RCONTROL") == 0 ) {
                vKey = 0x0A3; // 'Right CONTROL key
                return vKey;
        }
        if(stricmp(szSearch,"LMENU") == 0 ) {
                vKey = 0x0A4; // 'Left MENU key
                return vKey;
        }
        if(stricmp(szSearch,"RMENU") == 0 ) {
                vKey = 0x0A5; // 'Right MENU key
                return vKey;
        }
        if(stricmp(szSearch,"BROWSER_BACK") == 0 ) {
                vKey = 0x0A6; // 'Windows 2000: Browser Back key
                return vKey;
        }
        if(stricmp(szSearch,"BROWSER_FORWARD") == 0 ) {
                vKey = 0x0A7; // 'Windows 2000: Browser Forward key
                return vKey;
        }
        if(stricmp(szSearch,"BROWSER_REFRESH") == 0 ) {
                vKey = 0x0A8; // 'Windows 2000: Browser Refresh key
                return vKey;
        }
        if(stricmp(szSearch,"BROWSER_STOP") == 0 ) {
                vKey = 0x0A9; // 'Windows 2000: Browser Stop key
                return vKey;
        }
        if(stricmp(szSearch,"BROWSER_SEARCH") == 0 ) {
                vKey = 0x0AA; // 'Windows 2000: Browser Search key
                return vKey;
        }
        if(stricmp(szSearch,"BROWSER_FAVORITES") == 0 ) {
                vKey = 0x0AB; // 'Windows 2000: Browser Favorites key
                return vKey;
        }
        if(stricmp(szSearch,"BROWSER_HOME") == 0 ) {
                vKey = 0x0AC; // 'Windows 2000: Browser Start and Home key
                return vKey;
        }
        if(stricmp(szSearch,"VOLUME_MUTE") == 0 ) {
                vKey = 0x0AD; // 'Windows 2000: Volume Mute key
                return vKey;
        }
        if(stricmp(szSearch,"VOLUME_DOWN") == 0 ) {
                vKey = 0x0AE; // 'Windows 2000: Volume Down key
                return vKey;
        }
        if(stricmp(szSearch,"VOLUME_UP") == 0 ) {
                vKey = 0x0AF; // 'Windows 2000: Volume Up key
                return vKey;
        }
        if(stricmp(szSearch,"MEDIA_NEXT_TRACK") == 0 ) {
                vKey = 0x0B0; // 'Windows 2000: Next Track key
                return vKey;
        }
        if(stricmp(szSearch,"MEDIA_PREV_TRACK") == 0 ) {
                vKey = 0x0B1; // 'Windows 2000: Previous Track key
                return vKey;
        }
        if(stricmp(szSearch,"MEDIA_STOP") == 0 ) {
                vKey = 0x0B2; // 'Windows 2000: Stop Media key
                return vKey;
        }
        if(stricmp(szSearch,"MEDIA_PLAY_PAUSE") == 0 ) {
                vKey = 0x0B3; // 'Windows 2000: Play/Pause Media key
                return vKey;
        }
        if(stricmp(szSearch,"LAUNCH_MAIL") == 0 ) {
                vKey = 0x0B4; // 'Windows 2000: Start Mail key
                return vKey;
        }
        if(stricmp(szSearch,"LAUNCH_MEDIA_SELECT") == 0 ) {
                vKey = 0x0B5; // 'Windows 2000: Select Media key
                return vKey;
        }
        if(stricmp(szSearch,"LAUNCH_APP1") == 0 ) {
                vKey = 0x0B6; // 'Windows 2000: Start Application 1 key
                return vKey;
        }
        if(stricmp(szSearch,"LAUNCH_APP2") == 0 ) {
                vKey = 0x0B7; // 'Windows 2000: Start Application 2 key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_1") == 0 ) {
                vKey = 0x0BA; // 'Windows 2000: For the US standard keyboard, the ';:' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_PLUS") == 0 ) {
                vKey = 0x0BB; // 'Windows 2000: For any country/region, the '+' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_COMMA") == 0 ) {
                vKey = 0x0BC; // 'Windows 2000: For any country/region, the ',' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_MINUS") == 0 ) {
                vKey = 0x0BD; // 'Windows 2000: For any country/region, the '-' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_PERIOD") == 0 ) {
                vKey = 0x0BE; // 'Windows 2000: For any country/region, the '.' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_2") == 0 ) {
                vKey = 0x0BF; // 'Windows 2000: For the US standard keyboard, the '/?' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_3") == 0 ) {
                vKey = 0x0C0; // 'Windows 2000: For the US standard keyboard, the '`~' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_4") == 0 ) {
                vKey = 0x0DB; // 'Windows 2000: For the US standard keyboard, the '[{' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_5") == 0 ) {
                vKey = 0x0DC; // 'Windows 2000: For the US standard keyboard, the '\|' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_6") == 0 ) {
                vKey = 0x0DD; // 'Windows 2000: For the US standard keyboard, the ']}' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_7") == 0 ) {
                vKey = 0x0DE; // 'Windows 2000: For the US standard keyboard, the 'single-quote/double-quote' key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_8") == 0 ) {
                vKey = 0x0DF; // '
                return vKey;
        }
        if(stricmp(szSearch,"OEM_102") == 0 ) {
                vKey = 0x0E2; // 'Windows 2000: Either the angle bracket key or the backslash key on the RT 102-key keyboard
                return vKey;
        }
        if(stricmp(szSearch,"PROCESSKEY") == 0 ) {
                vKey = 0x0E5; // 'Windows 95/98, Windows NT 4.0, Windows 2000: IME PROCESS key
                return vKey;
        }
        if(stricmp(szSearch,"PACKET") == 0 ) {
                vKey = 0x0E7; // 'Windows 2000: Used to pass Unicode characters as if they were keystrokes. The PACKET key is the low word of a 32-bit Virtual Key value used for non-keyboard input methods. For more information, see Remark in KEYBDINPUT, SendInput, WM_KEYDOWN, and WM_KEYUP
                return vKey;
        }
        if(stricmp(szSearch,"ATTN") == 0 ) {
                vKey = 0x0F6; // 'Attn key
                return vKey;
        }
        if(stricmp(szSearch,"CRSEL") == 0 ) {
                vKey = 0x0F7; // 'CrSel key
                return vKey;
        }
        if(stricmp(szSearch,"EXSEL") == 0 ) {
                vKey = 0x0F8; // 'ExSel key
                return vKey;
        }
        if(stricmp(szSearch,"EREOF") == 0 ) {
                vKey = 0x0F9; // 'Erase EOF key
                return vKey;
        }
        if(stricmp(szSearch,"PLAY") == 0 ) {
                vKey = 0x0FA; // 'Play key
                return vKey;
        }
        if(stricmp(szSearch,"ZOOM") == 0 ) {
                vKey = 0x0FB; // 'Zoom key
                return vKey;
        }
        if(stricmp(szSearch,"NONAME") == 0 ) {
                vKey = 0x0FC; // 'Reserved for future use
                return vKey;
        }
        if(stricmp(szSearch,"PA1") == 0 ) {
                vKey = 0x0FD; // 'PA1 key
                return vKey;
        }
        if(stricmp(szSearch,"OEM_CLEAR") == 0 ) {
                vKey = 0x0FE; // 'Clear key
                return vKey;
        }
        vKey = (unsigned int)szSearch;
        return vKey;
}
//----------------------------------------------------------------------------//
AnsiString __fastcall GetIniString(TIniFile *pIni,AnsiString Section,AnsiString Key,AnsiString Default)
{
  char *szMagicWord="**(~!@#$%^&)**";
  AnsiString  asDef;
  asDef=pIni->ReadString(Section,Key,szMagicWord);
  if(asDef==szMagicWord)  // INI ɤS
  {
    pIni->WriteString(Section,Key,Default);
    return Default;
  }
  else
    return asDef;
}
//----------------------------------------------------------------------------//
//---------------------------------------------------------------------------
// Value of PlatformID
// VER_PLATFORM_WIN32s            Win32s on Windows 3.1.
// VER_PLATFORM_WIN32_WINDOWS     Win32 on Windows 95 or Windows 98.
// VER_PLATFORM_WIN32_NT          Win32 on Windows NT.
int __fastcall TFormStatPlus::GetPlatformID(void)
{
  try
  {
    static DWORD    dwID = 0;
    OSVERSIONINFO   os_info;

    if (dwID == 0)
    {
      memset(&os_info, 0, sizeof(os_info));
      os_info.dwOSVersionInfoSize = sizeof (os_info);
      GetVersionEx(&os_info);

      dwID = os_info.dwPlatformId;
      if(dwID==VER_PLATFORM_WIN32_NT)
      {
        if(os_info.dwMajorVersion>=5) // 2000/XP ΥHW
          bEnableFade=true;
      }
    }
    return dwID;
  }
  catch(...)// You should always catch by reference.
  {
    return 0;
  }
}
//----------------------------------------------------------------------------//
__fastcall TFormStatPlus::TFormStatPlus(TComponent* Owner)
  : TForm(Owner)
{
  bEnableFade=false;
  iPlatformID=-999999;
  iPlatformID=GetPlatformID();
  if(bEnableFade==false)  // 0.0.8 fix Win98 S Fade \
  {
    mnuFade->Visible=false;
  }

  bCanClose=false;
  __bStopGetCPUUsage=false;

  GlobalMemoryStatus(&MemoryStatus);
  MEMStatus->MaxValue=MemoryStatus.dwTotalPhys;
  SWPStatus->MaxValue=MemoryStatus.dwTotalPageFile;

  iAutoFreeCount=0;
  iUnit=1;
//  INI ɪɦWAϥ TRegIniFile wOsb HKEY_CURRENT_USER U
// ɦWG  \Software\[ɥDɦW]
// WG  HKEY_CURRENT_USER\Software\[ɥDɦW]
  IniFileName = ExtractFileName(Application->ExeName);
  IniFileName = "\\Software\\"+IniFileName.SubString(1, IniFileName.Length() - 4);

//  y INI ɪɦW
  LangIniFileName = Application->ExeName;
  LangIniFileName = LangIniFileName.SubString(1,LangIniFileName.Length()-3)+"ini";

  asPhyMem="O";
  asAvlMem="iΰO";
  asMemFreeing="O...";
  asMemFreeComplete="O!!";
  asBatCharging="qRq";
  asBatDisCharging="qq";
  asUseACPower="ϥΥq";
  asNoBatInfo="SqT";

  bCustomDateTimeString=false;
  CustomDateTiemString="mm-dd hh:nn";
  EnableMemInfo=true;
  EnableSwapInfo=true;
  EnableBatteryInfo=true;

  this->Left=Screen->Width-this->Width;
  this->Top=0;

  HotKeyList=new TStringList;
  LoadRegIniSetting();
  TimerGUIUpdateTimer(TimerGUIUpdate);
  TimerGUIUpdate->Enabled=true;

        TrayMessage(NIM_ADD);
  TrayMessage(NIM_MODIFY);
}
//----------------------------------------------------------------------------//
__fastcall TFormStatPlus::~TFormStatPlus()
{
  TRegIniFile  *pReg=new TRegIniFile(IniFileName);      // Open INI file
  try
  {
    pReg->WriteInteger(EmptyStr,"Left",this->Left);
    pReg->WriteInteger(EmptyStr,"Top",this->Top);
  }
  __finally
  {
    delete pReg;
  }

  for(int i=2;i<=12;i++)
  {
    if(HotKeyRegistered[i])
    {
      UnregisterHotKey(this->Handle,HotKeyID[i]);
    }
  }
  if(HotKeyList!=NULL) delete HotKeyList;
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::LoadRegIniSetting(void)
{
  TRegIniFile  *pReg=new TRegIniFile(IniFileName);      // Open INI file
  try
  {
    if(pReg->ValueExists("Left"))
      this->Left=pReg->ReadInteger(EmptyStr,"Left",this->Left);
    else
      pReg->WriteInteger(EmptyStr,"Left",this->Left);

    if(pReg->ValueExists("Top"))
      this->Top=pReg->ReadInteger(EmptyStr,"Top",this->Top);
    else
      pReg->WriteInteger(EmptyStr,"Top",this->Top);

    for(int i=2;i<=12;i++)
      HotKeyWinF[i]=pReg->ReadString(EmptyStr,"WinF"+IntToStr(i),EmptyStr);
    for(int i=0;i<13;i++)
    {
      HotKeyRegistered[i]=false;
      HotKeyID[i]=-1;
    }

    if(bEnableFade) // fixed for Win98
    {
      mnuFade->Checked=pReg->ReadBool(EmptyStr,"Fade",true);
      if(mnuFade->Checked)
        SetTransparent(200);
      else
        ClearTransparent();
    }
    mnuOnTop->Checked=pReg->ReadBool(EmptyStr,"OnTop",true);
    if(mnuOnTop->Checked)
      SetTopMost();
    else
      ClearTopMost();


    if(pReg->ValueExists("EnableCustomDateTimeString"))
      bCustomDateTimeString=pReg->ReadBool(EmptyStr,"EnableCustomDateTimeString",false);
    else
      pReg->WriteBool(EmptyStr,"EnableCustomDateTimeString",bCustomDateTimeString);

    if(pReg->ValueExists("CustomDateTimeString"))
      CustomDateTiemString=pReg->ReadString(EmptyStr,"CustomDateTimeString","mm-dd hh:nn");
    else
      pReg->WriteString(EmptyStr,"CustomDateTimeString",CustomDateTiemString);

    cTrayIconColor=(TColor)pReg->ReadInteger(EmptyStr,"IconColor",8388608);
    FontName=pReg->ReadString(EmptyStr,"IconFont","MS Serif");
    FontSize[0]=pReg->ReadInteger(EmptyStr,"IconFontSize1",12);
    FontSize[1]=pReg->ReadInteger(EmptyStr,"IconFontSize2",11);
    FontSize[2]=pReg->ReadInteger(EmptyStr,"IconFontSize3",9);
    FontSize[3]=pReg->ReadInteger(EmptyStr,"IconFontSize4",9);
    bAutoFreeMem=pReg->ReadBool(EmptyStr,"AutoFree",false);
    mnuAutoFree->Checked=bAutoFreeMem;
    mnuAutoTrigger->Checked=mnuAutoFree->Checked;

    AutoFreeTimeIndex=pReg->ReadInteger(EmptyStr,"AutoFreeTimeIndex",3);
    if(AutoFreeTimeIndex<1 || AutoFreeTimeIndex>3)  AutoFreeTimeIndex=3;
    switch(AutoFreeTimeIndex)
    {
      case 1:
        mnuAuto1Min->Checked=true;
        iAutoFreeInterval=60;
        break;
      case 2:
        mnuAuto5Min->Checked=true;
        iAutoFreeInterval=60*5;
        break;
      case 3:
        mnuAuto10Min->Checked=true;
        iAutoFreeInterval=60*10;
        break;
    }

    AutoFreeMBIndex=pReg->ReadInteger(EmptyStr,"AutoFreeMBIndex",3);
    if(AutoFreeMBIndex<1 || AutoFreeMBIndex>6)  AutoFreeMBIndex=3;
    switch(AutoFreeMBIndex)
    {
      case 1:
        mnuAuto16MB->Checked=true;
        iAutoFreeSize=16;
        bAutoFreeMoreMem=false;
        break;
      case 2:
        mnuAuto32MB->Checked=true;
        iAutoFreeSize=32;
        bAutoFreeMoreMem=false;
        break;
      case 3:
        mnuAuto64MB->Checked=true;
        iAutoFreeSize=64;
        bAutoFreeMoreMem=false;
        break;
      case 4:
        mnuAuto128MB->Checked=true;
        iAutoFreeSize=128;
        bAutoFreeMoreMem=false;
        break;
      case 5:
        mnuAutoMore4MB->Checked=true;
        iAutoFreeSize=4;
        bAutoFreeMoreMem=true;
        break;
      case 6:
        mnuAutoMore8MB->Checked=true;
        iAutoFreeSize=8;
        bAutoFreeMoreMem=true;
        break;
      case 7:
        mnuAutoMore16MB->Checked=true;
        iAutoFreeSize=16;
        bAutoFreeMoreMem=true;
        break;
    }

    TrayIconIndex=pReg->ReadInteger(EmptyStr,"TrayIconIndex",1);
    if(TrayIconIndex<1 || TrayIconIndex>3)  TrayIconIndex=1;
    switch(TrayIconIndex)
    {
      case 1:
        mnuTrayCPU->Checked=true;
        break;
      case 2:
        mnuTrayMEM->Checked=true;
        break;
      case 3:
        mnuTrayBAT->Checked=true;
        break;
    }

    if(pReg->ValueExists("EnableBatteryInfo"))
      EnableBatteryInfo=pReg->ReadBool(EmptyStr,"EnableBatteryInfo",EnableBatteryInfo);
    else
      pReg->ReadBool(EmptyStr,"EnableBatteryInfo",EnableBatteryInfo);
    EnableBatteryInfo=!EnableBatteryInfo;
    mnuBatteryInfoClick(mnuBatteryInfo);

    if(pReg->ValueExists("EnableSwapInfo"))
      EnableSwapInfo=pReg->ReadBool(EmptyStr,"EnableSwapInfo",EnableSwapInfo);
    else
      pReg->ReadBool(EmptyStr,"EnableSwapInfo",EnableSwapInfo);
    EnableSwapInfo=!EnableSwapInfo;
    mnuSwapInfoClick(mnuSwapInfo);

    if(pReg->ValueExists("EnableMemInfo"))
      EnableMemInfo=pReg->ReadBool(EmptyStr,"EnableMemInfo",EnableMemInfo);
    else
      pReg->ReadBool(EmptyStr,"EnableMemInfo",EnableMemInfo);
    EnableMemInfo=!EnableMemInfo;
    mnuMemInfoClick(mnuMemInfo);

    TShiftState ss;
    CPUStatusMouseUp(CPUStatus,mbLeft,ss,0,0);
  }
  __finally
  {
    delete pReg;
  }

  TIniFile  *pIni=new TIniFile(LangIniFileName);      // Open INI file
  try
  {
    asPhyMem=GetIniString(pIni,"Memory","PhysicalMemory",asPhyMem);
    asAvlMem=GetIniString(pIni,"Memory","AvailableMemory",asAvlMem);
    asMemFreeing=GetIniString(pIni,"Memory","FreeingMemory",asMemFreeing);
    asMemFreeComplete=GetIniString(pIni,"Memory","FreeMemoryComplete",asMemFreeComplete);
    asBatCharging=GetIniString(pIni,"Battery","BatCharging",asBatCharging);
    asBatDisCharging=GetIniString(pIni,"Battery","BatDisCharging",asBatDisCharging);
    asUseACPower=GetIniString(pIni,"Battery","UseACPower",asUseACPower);
    asNoBatInfo=GetIniString(pIni,"Battery","NoBatInfo",asNoBatInfo);

    for(int i=0;i<this->ComponentCount;i++)
    {
      TMenuItem *item=dynamic_cast<TMenuItem *>(Components[i]);
      if(item!=NULL)
      {
        if(item->Name.Pos("mnuSep")>0) continue;  // jAŪ INI
        item->Caption=GetIniString(pIni,"Menu",item->Name+"Caption",item->Caption);
        item->Hint=GetIniString(pIni,"Menu",item->Name+"Hint",item->Hint);
      }
    }
  }
  __finally
  {
    delete pIni;
  }
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::SaveRegIniSetting(void)
{
  TRegIniFile  *pReg=new TRegIniFile(IniFileName);      // Open INI file
  try
  {
    pReg->WriteInteger(EmptyStr,"IconColor",(int)cTrayIconColor);
    pReg->WriteString(EmptyStr,"IconFont",FontName);
    pReg->WriteInteger(EmptyStr,"IconFontSize1",FontSize[0]);
    pReg->WriteInteger(EmptyStr,"IconFontSize2",FontSize[1]);
    pReg->WriteInteger(EmptyStr,"IconFontSize3",FontSize[2]);
    pReg->WriteInteger(EmptyStr,"IconFontSize4",FontSize[3]);
    pReg->WriteBool(EmptyStr,"AutoFree",bAutoFreeMem);

    pReg->WriteBool(EmptyStr,"Fade",mnuFade->Checked);
    pReg->WriteBool(EmptyStr,"OnTop",mnuOnTop->Checked);
    pReg->WriteBool(EmptyStr,"EnableBatteryInfo",mnuBatteryInfo->Checked);
    pReg->WriteBool(EmptyStr,"EnableSwapInfo",mnuSwapInfo->Checked);
    pReg->WriteBool(EmptyStr,"EnableMemInfo",mnuMemInfo->Checked);

    pReg->WriteInteger(EmptyStr,"AutoFreeTimeIndex",AutoFreeTimeIndex);
    pReg->WriteInteger(EmptyStr,"AutoFreeMBIndex",AutoFreeMBIndex);
    pReg->WriteInteger(EmptyStr,"TrayIconIndex",TrayIconIndex);
  }
  __finally
  {
    delete pReg;
  }
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::TimerGUIUpdateTimer(TObject *Sender)
{
  iUpdateTime++;
//  bool bTrayUpdate=false;
  GlobalMemoryStatus(&MemoryStatus);
  if(iUpdateTime%8==0)
    bShowTotalorAvail=!bShowTotalorAvail;
  if(bShowTotalorAvail)
  {
    int value=MemoryStatus.dwTotalPhys-MemoryStatus.dwAvailPhys;
    if(MEMStatus->UserValue!=value)
    {
      MEMStatus->UserValue=value;
      MEMStatus->Caption=IntToStr(value)+" / "+IntToStr(MemoryStatus.dwTotalPhys);
    }
    value=MemoryStatus.dwTotalPageFile-MemoryStatus.dwAvailPageFile;
    if(SWPStatus->UserValue!=value)
    {
      SWPStatus->UserValue=value;
      SWPStatus->Caption=IntToStr(value)+" / "+IntToStr(MemoryStatus.dwTotalPageFile);
    }
  }
  else
  {
    int value=MemoryStatus.dwTotalPhys-MemoryStatus.dwAvailPhys;
    if(MEMStatus->UserValue!=value)
    {
      MEMStatus->UserValue=value;
      MEMStatus->Caption=IntToStr(value)+" / "+IntToStr(MemoryStatus.dwAvailPhys);
    }
    value=MemoryStatus.dwTotalPageFile-MemoryStatus.dwAvailPageFile;
    if(SWPStatus->UserValue!=value)
    {
      SWPStatus->UserValue=value;
      SWPStatus->Caption=IntToStr(value)+" / "+IntToStr(MemoryStatus.dwAvailPageFile);
    }
  }
  int iThisAvailMem=MemoryStatus.dwAvailPhys>>20;

  SYSTEM_POWER_STATUS s;

  if(EnableBatteryInfo)
  {
    if(GetSystemPowerStatus(&s))
    {
      //  ListBox1->Items->Add("s.ACLineStatus        " +IntToStr(s.ACLineStatus));
      //  ListBox1->Items->Add("s.BatteryFlag         " +IntToStr(s.BatteryFlag ));
      //  ListBox1->Items->Add("s.BatteryLifePercent  " +IntToStr(s.BatteryLifePercent  ));
      if(s.ACLineStatus==1)
      {
        if((s.BatteryFlag & BATTERY_FLAG_CHARGING)==BATTERY_FLAG_CHARGING)
          BATStatus->Caption=asBatCharging+" "+IntToStr(s.BatteryLifePercent)+" %";
        else
          BATStatus->Caption=asUseACPower+" "+IntToStr(s.BatteryLifePercent)+" %";
      }
      else
      {
        if(s.BatteryLifeTime==0xFFFFFFFF)
          BATStatus->Caption=asBatDisCharging+" "+IntToStr(s.BatteryLifePercent)+" %";
        else
        {
          BATStatus->Caption=TDateTime(double(s.BatteryLifeTime)*1.1574074E-5).FormatString("h:nn")
                            +" "+asBatDisCharging+" "+IntToStr(s.BatteryLifePercent)+" %";
        }
      }
      if(BATStatus->UserValue!=s.BatteryLifePercent)
        BATStatus->UserValue=s.BatteryLifePercent;
    }
    else
    {
      BATStatus->Caption=asNoBatInfo;
      s.BatteryLifePercent=100;
      if(BATStatus->UserValue!=s.BatteryLifePercent)
        BATStatus->UserValue=s.BatteryLifePercent;
    }
  }
  int iCPUusage=GetCPUUsage();
  AnsiString asCPU;
  asCPU.printf("%d%% ",iCPUusage);
  TDateTime dt=Now();

  if(bCustomDateTimeString)
  {
    try{
      CPUStatus->Caption=asCPU+dt.FormatString(CustomDateTiemString);
    }catch(...){
      CPUStatus->Caption=asCPU+dt.FormatString("mm-dd hh:nn");
    }
  }
  else
  {
    CPUStatus->Caption=asCPU+dt.FormatString("mmm d ")
                      +asWeekDay[dt.DayOfWeek()%7]
                      +dt.FormatString(" hh:nn");
  }
  if(CPUStatus->UserValue!=iCPUusage)
    CPUStatus->UserValue=iCPUusage;

  int iThisInfo=0;
  switch(TrayIconIndex)
  {
    case 1: // CPU
      iThisInfo=iCPUusage;
      break;
    case 2: // MEM
      iThisInfo=iThisAvailMem;
      break;
    case 3: // BAT
      if(EnableBatteryInfo) iThisInfo=s.BatteryLifePercent;
      else                  iThisInfo=100;
      break;
  }

  if(bEnableFade)
  {
    iShowFadeCount--;
    if(iShowFadeCount==0)
    {
      if(mnuFade->Checked)  // ]w Fade ,~ݭnN]z
        SetTransparent(200);
      iMovingInCount=0;     // Jpks,HKUJ,ߧYܤz
    }
  }

  // AutoFree
  if(bAutoFreeMem && iAutoFreeInterval>0)
  {
    iAutoFreeCount++;
    if(iAutoFreeCount>iAutoFreeInterval)
    {
      iAutoFreeCount=0;
      if(bAutoFreeMoreMem)                    // Lצp󳣭n Free Memory
      {
        FreeMemory(iThisAvailMem+iAutoFreeSize);
      }
      else if(iThisAvailMem < iAutoFreeSize)  // OLpɤ~ Free
      {
        FreeMemory(iAutoFreeSize);
      }
    }
  }
  if(iLastInfo!=iThisInfo || (bAutoFreeMem && iAutoFreeInterval>0))
  {
    iLastInfo=iThisInfo;
    TrayMessage(NIM_MODIFY);
  }
}
//----------------------------------------------------------------------------////----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::CBoxUnitChange(TObject *Sender)
{
/*
  switch(CBoxUnit->ItemIndex)
  {
    case 0: // byte
      iUnit=1;
      break;
    case 1: // KB
      iUnit=1024;
      break;
    case 2: // MB
      iUnit=1024*1024;
      break;
  }
*/
}
//----------------------------------------------------------------------------////----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::FreeMemory(int iFreeSize)
{
    iFreeingPercent=0;
    bFreeingMem=true;
    mnuAbort->Enabled=true;

    int iMaxFreeSize=(MemoryStatus.dwTotalPhys>>20)-32;
    if(iFreeSize>iMaxFreeSize)
      iFreeSize=iMaxFreeSize;

    this->MemoryFreeStatusString=asMemFreeing;
    iFreeSize=iFreeSize << 20;

// k1GL
// char *pBuffer=new char[iFreeSize];
// delete [] pBuffer;

// k2GġAnuhsƤ~|utmHI
    char *pBuffer=new char[iFreeSize];
    int iStep=4*1024;           // 絲GH 2K ̬ġA4K ]iA8K ӤjN
    for(int i=iStep-1;i<iFreeSize;i+=iStep)  // H K A[֦sɶ
    {
      if(bAbort) break;         // pGnDAhAVtέnO
      pBuffer[i]=0x0;
      iFreeingPercent=((i+1)>>10)*100/(iFreeSize>>10);
      this->MemoryFreeStatusString=asMemFreeing+IntToStr(iFreeingPercent)+" %";
      Application->ProcessMessages();
    }
    delete [] pBuffer;
    this->MemoryFreeStatusString=asMemFreeComplete;

    mnuAbort->Enabled=false;
    bAbort=false;
    bFreeingMem=false;

    TimerGUIUpdateTimer(TimerGUIUpdate);
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  if(!bCanClose)    // pGObϥΤU Alt-F4 άO [X]
  {
    Action=caNone;  // h{
    Hide();         // uON
  }
// Heϥ FormCloseQuery(TObject *Sender,bool &CanClose)
// Ө{`AunN CanClose ] false YiC
// Oϥ FormCloseQuery() IOA
// tεnXɡA{|ϱotΤ@b{C
//
//  FormClose(TObject *Sender, TCloseAction &Action)
// @˥iH{`ALS FormCloseQuery() IC
// n@줣{`AunN Action ] caNone YiC
//  SDI w Action  caHide AҥHApGn`]iH] caHide
// ~A]iH] caFree ϱoPɱNeΪOC
}

//----------------------------------------------------------------------------//
// From TrayIcon Example (BCB5)
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::FormDestroy(TObject *Sender)
{
        TrayMessage(NIM_DELETE);
  __bStopGetCPUUsage=true;
  GetCPUUsage();            // for Win9X,Me to Stop CPU Usage counter
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::DrawItem(TMessage& Msg)
{
  IconDrawItem((LPDRAWITEMSTRUCT)Msg.LParam);
  TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
void __fastcall TFormStatPlus::MyNotify(TMessage& Msg)
{
  POINT MousePos;

  switch(Msg.LParam)
  {
    case WM_RBUTTONUP:
    // case WM_LBUTTONUP:
      if (GetCursorPos(&MousePos))
      {
        PopupMenu->PopupComponent = FormStatPlus;
        SetForegroundWindow(Handle);
        PopupMenu->Popup(MousePos.x, MousePos.y);
      }
      else
        Show();
      break;
    case WM_LBUTTONDBLCLK:
    //case WM_NCRBUTTONDBLCLK:
    //case WM_RBUTTONDBLCLK:
      if(this->Visible)
        Hide();
      else
        Show();
      break;
    default:
      break;
  }
  TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
void __fastcall TFormStatPlus::MyNotifyShow(TMessage& Msg)
{
  Show();
  TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
// WM_HOTKEY
// idHotKey = (int) wParam;              // identifier of hot key
// fuModifiers = (UINT) LOWORD(lParam);  // key-modifier flags
// uVirtKey = (UINT) HIWORD(lParam);     // virtual-key code
void __fastcall TFormStatPlus::MyHotKey(TMessage& Msg)
{
  int NeedToRunCommand=0;
  switch(Msg.LParamHi)
  {
    // case 0x070: // F1
    case 0x071: // F2
      NeedToRunCommand=2;
      break;
    case 0x072: // F3
      NeedToRunCommand=3;
      break;
    case 0x073: // F4
      NeedToRunCommand=4;
      break;
    case 0x074: // F5
      NeedToRunCommand=5;
      break;
    case 0x075: // F6
      NeedToRunCommand=6;
      break;
    case 0x076: // F7
      NeedToRunCommand=7;
      break;
    case 0x077: // F8
      NeedToRunCommand=8;
      break;
    case 0x078: // F9
      NeedToRunCommand=9;
      break;
    case 0x079: // F10
      NeedToRunCommand=10;
      break;
    case 0x07A: // F11
      NeedToRunCommand=11;
      break;
    case 0x07B: // F12
      NeedToRunCommand=12;
      break;
  }

  if(NeedToRunCommand==0) return;

  AnsiString asFunction=HotKeyWinF[NeedToRunCommand];

  if(asFunction.Length()==0) return;

  // ثe䴩HUwO
  // **Show**
  // **Hide**
  // **Trigger** (**ShowTrigger**,  **ShowTrig**)
  // **OnTop**
  // **NotOnTop**
  // **OnTopTrigger** (**OnTopTrig**)
  // **FadeTrigger** (**FadeTrig**)
  // **ShowHotkeys**" (**ShowHotkey**)
  // **ScreenSave**
  // **FreeMem**Size
  // **FreeMoreMem**Size
  AnsiString asFUNCTION=asFunction.UpperCase();
  if(asFUNCTION=="**SHOW**")
  {
    Show();
      if(!mnuOnTop->Checked)  // w]w OnTopAhA OnTop
      {                       // _h OnTopAA OnTop
        SetTopMost();
        ClearTopMost();
      }
    return;
  }
  else if(asFUNCTION=="**HIDE**")
  {
    Hide();
    return;
  }
  else if(asFUNCTION=="**TRIGGER**" || asFUNCTION=="**SHOWTRIGGER**" || asFUNCTION=="**SHOWTRIG**")
  {
    // mnuShowClick(mnuShow);
    if(this->Visible)
      Hide();
    else
    {
      Show();
        if(!mnuOnTop->Checked)  // w]w OnTopAhA OnTop
        {                       // _h OnTopAA OnTop
          SetTopMost();
          ClearTopMost();
        }
    }
    return;
  }
  else if(asFUNCTION=="**SHOWHOTKEYS**" || asFUNCTION=="**SHOWHOTKEY**")
  {
    mnuShowKeysClick(mnuShowKeys);
    return;
  }
  else if(asFUNCTION=="**ONTOP**")
  {
    // this->FormStyle=fsStayOnTop;
    if(this->Visible==false) Show();
      SetTopMost();
      mnuOnTop->Checked=true;
    return;
  }
  else if(asFUNCTION=="**NOTONTOP**")
  {
    // this->FormStyle=fsNormal;
      ClearTopMost();
      mnuOnTop->Checked=false;
    return;
  }
  else if(asFUNCTION=="**ONTOPTRIGGER**" || asFUNCTION=="**ONTOPTRIG**")
  {
    mnuOnTopClick(mnuOnTop);
    /*
    if(mnuOnTop->Checked)
    {
      ClearTopMost();
      mnuOnTop->Checked=false;
    }
    else
    {
      if(this->Visible==false) Show();
      SetTopMost();
      mnuOnTop->Checked=true;
    }
    */
    /*
    if(this->FormStyle!=fsStayOnTop)
    {
      this->FormStyle=fsStayOnTop;
      mnuOnTop->Checked=true;
      if(this->Visible==false) Show();
    }
    else
    {
      this->FormStyle=fsNormal;
      mnuOnTop->Checked=false;
    }
    */
    return;
  }
  else if(asFUNCTION=="**FADETRIGGER**" || asFUNCTION=="**FADETRIG**")
  {
    mnuFadeClick(mnuFade);
    return;
  }
  else if(asFUNCTION=="**SCREENSAVE**")
  {
    mnuScreenSaveClick(mnuScreenSave);
    return;
  }
  else if(asFUNCTION.SubString(1,11)=="**FREEMEM**")
  {
    int iSize=StrToIntDef(asFUNCTION.SubString(12,asFUNCTION.Length()-11),0);
    if(iSize<=0) return;
    FreeMemory(iSize);
    return;
  }
  else if(asFUNCTION.SubString(1,15)=="**FREEMOREMEM**")
  {
    int iSize=StrToIntDef(asFUNCTION.SubString(16,asFUNCTION.Length()-15),0);
    if(iSize<=0) return;
    FreeMemory((MemoryStatus.dwAvailPhys>>20)+iSize);
    return;
  }

  AnsiString asEXE=EmptyStr;
  AnsiString asPATH=EmptyStr;
  AnsiString asPARAM=EmptyStr;
  if(asFunction.AnsiPos(" ")==0)  // SťաAYDɦW]LROCѼ
  {
    asEXE=asFunction;
    asPATH=ExtractFilePath(asEXE);
  }
  else if(asFunction[1]=='"')     // D{ɦW
  {
    for(int i=2;i<=asFunction.Length();i++)
    {
      if(asFunction[i]=='"')
      {
        asEXE=asFunction.SubString(2,i-2);
        asPATH=ExtractFilePath(asEXE);
        asPARAM=asFunction.SubString(i+1,asFunction.Length()-i);
        asPARAM=asPARAM.Trim();
        break;
      }
    }
  }
  else
  {
    int iSpace=asFunction.AnsiPos(" ");
    asEXE=asFunction.SubString(1,iSpace);
    asPATH=ExtractFilePath(asEXE);
    asPARAM=asFunction.SubString(iSpace+1,asFunction.Length()-iSpace);
    asPARAM=asPARAM.Trim();
  }
  ShellExecute(Application->Handle, "open",
               asEXE.c_str(),asPARAM.c_str(), asPATH.c_str(),
               SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------
bool __fastcall TFormStatPlus::TrayMessage(DWORD dwMessage)
{
  NOTIFYICONDATA tnd;
  PSTR pszTip;

  pszTip = TipText();

  tnd.cbSize          = sizeof(NOTIFYICONDATA);
  tnd.hWnd            = Handle;
  tnd.uID             = IDC_MYICON;
  tnd.uFlags          = NIF_MESSAGE | NIF_ICON | NIF_TIP;
  tnd.uCallbackMessage= MYWM_NOTIFY;

  if (dwMessage == NIM_MODIFY)
  {
    tnd.hIcon           = (HICON)IconHandle();
  }
  else
  {
    tnd.hIcon = NULL;
  }
  if (pszTip)
    lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
        else
    tnd.szTip[0] = '\0';

  return (Shell_NotifyIcon(dwMessage, &tnd));
}
//---------------------------------------------------------------------------
void __fastcall TFormStatPlus::TextToIconBitmap(
    Graphics::TBitmap *pBmpColor, TColor cBGColor, TColor cFGColor,
    Graphics::TBitmap *pBmpMask,  TColor cBGMask,  TColor cFGMask,
    AnsiString asText,AnsiString asFontName,int iFontSize)
{
  TRect thisRect=Rect(0,0,16,16);
  pBmpColor->PixelFormat=pf8bit;
  pBmpColor->HandleType=bmDDB;
  pBmpColor->Height=16;
  pBmpColor->Width=16;
  pBmpColor->Canvas->Font->Name=asFontName;
  pBmpColor->Canvas->Font->Size=iFontSize;
  pBmpColor->Canvas->Font->Color=cFGColor;
  pBmpColor->Canvas->Brush->Color=cBGColor;
  pBmpColor->Canvas->FillRect(thisRect);

  int iLeft=pBmpColor->Canvas->TextWidth(asText);
  int iTop=pBmpColor->Canvas->TextHeight(asText);
  iLeft=(16-iLeft)>>1;
  iTop=(16-iTop)>>1;
  pBmpColor->Canvas->TextRect(thisRect,iLeft,iTop,asText);

  pBmpMask->PixelFormat=pf8bit;
  pBmpMask->HandleType=bmDDB;
  pBmpMask->Height=16;
  pBmpMask->Width=16;
  pBmpMask->Canvas->Font->Name=asFontName;
  pBmpMask->Canvas->Font->Size=iFontSize;
  pBmpMask->Canvas->Font->Color=cFGMask;
  pBmpMask->Canvas->Brush->Color=cBGMask;
  pBmpMask->Canvas->FillRect(thisRect);
  pBmpMask->Canvas->TextRect(thisRect,iLeft,iTop,asText);
}
//---------------------------------------------------------------------------
HICON __fastcall TFormStatPlus::IconHandle(void)
{
/*
  static HICON hico=NULL;
  Graphics::TBitmap *pBmp = new Graphics::TBitmap;
  Graphics::TBitmap *pBmpBlack = new Graphics::TBitmap;

      TextToIconBitmap(pBmp,clBlack,clWhite,pBmpBlack,clWhite,clBlack,   // Lr
                       (IntToStr(iLastCPUusage)),"Arial",8);
  ICONINFO  ico;
  ico.fIcon=true;                       // ICONƱ Lmr  , mmr  h AND/XOR n@pU
  ico.hbmMask=pBmpBlack->Handle;        // AND Mask թ¦r  , ©¦r
  ico.hbmColor=pBmp->Handle;            // XOR Mask ©mr  , mmr
  if(hico!=NULL)DestroyIcon(hico);      //  CreateIconIndirect() ϥ DestroyIcon R
  hico=CreateIconIndirect(&ico);        // _h{ҨϥΪ GDI Ʒ|uWɡI
  delete pBmp;
  delete pBmpBlack;

  return hico;
*/

  static HICON hico=NULL;
  Graphics::TBitmap *pBmp = new Graphics::TBitmap;
  Graphics::TBitmap *pBmpBlack = new Graphics::TBitmap;

  if(bFreeingMem)
  {
    static int iCount=0;
    iCount++;
    if(iCount%2==0)
      TextToIconBitmap(pBmp,clBlack,clLime,pBmpBlack,clWhite,clBlack,   // Lr
                       (IntToStr(iFreeingPercent)),FontName,FontSize[3]);
    else
      TextToIconBitmap(pBmp,clGreen,clLime,pBmpBlack,clBlack,clBlack,   // 񩳺r
                       (IntToStr(iFreeingPercent)),FontName,FontSize[3]);
  }
  else
  {
    int iFontSize=FontSize[0];
    if(iLastInfo>=100)iFontSize=FontSize[2];
    else if(iLastInfo>=10)iFontSize=FontSize[1];

    TextToIconBitmap(pBmp,clBlack,cTrayIconColor,pBmpBlack,clWhite,clBlack,   // LŦr
                     IntToStr(iLastInfo),FontName,iFontSize);

    if(bAutoFreeMem && iAutoFreeInterval>0)
    {
        // O
        int pX[8]={0,3,6,9,12,9,6,3};
        static iX=0;
        TRect thisRect=Rect(pX[iX],14,pX[iX]+3,16);
        pBmp->Canvas->Brush->Color=clLime;
        pBmp->Canvas->FillRect(thisRect);
        pBmpBlack->Canvas->Brush->Color=clBlack;
        pBmpBlack->Canvas->FillRect(thisRect);
        iX=(iX+1)%8;
    }
  }
  ICONINFO  ico;
  ico.fIcon=true;                       // ICONƱ Lmr  , mmr  h AND/XOR n@pU
  ico.hbmMask=pBmpBlack->Handle;        // AND Mask թ¦r  , ©¦r
  ico.hbmColor=pBmp->Handle;            // XOR Mask ©mr  , mmr
  if(hico!=NULL)DestroyIcon(hico);      //  CreateIconIndirect() ϥ DestroyIcon R
  hico=CreateIconIndirect(&ico);        // _h{ҨϥΪ GDI Ʒ|uWɡI
  delete pBmp;
  delete pBmpBlack;

  return hico;

}
//---------------------------------------------------------------------------
PSTR __fastcall TFormStatPlus::TipText(void)
{
  if(bFreeingMem)
  {
    return  this->MemoryFreeStatusString.c_str();
  }
  else
  {
    static AnsiString as;   // pG Static ܡAǦ^ pointer @UNĤFII
    as.printf("%s: %d %s\n%s: %d %s",
               asPhyMem.c_str(),
               (MemoryStatus.dwTotalPhys / iUnit),(iUnit==1)?"Byte":((iUnit==1024)?"KB":"MB"),
               asAvlMem.c_str(),
               (MemoryStatus.dwAvailPhys / iUnit),(iUnit==1)?"Byte":((iUnit==1024)?"KB":"MB"));
    return (as.c_str());
  }
}
//---------------------------------------------------------------------------
LRESULT IconDrawItem(LPDRAWITEMSTRUCT lpdi)
{
        HICON hIcon;

        hIcon = (HICON)LoadImage(g_hinst, MAKEINTRESOURCE(lpdi->CtlID), IMAGE_ICON,
                16, 16, 0);
        if (!hIcon)
                return(FALSE);

        DrawIconEx(lpdi->hDC, lpdi->rcItem.left, lpdi->rcItem.top, hIcon,
                16, 16, 0, NULL, DI_NORMAL);

        return(TRUE);
}
//---------------------------------------------------------------------------
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuEXITClick(TObject *Sender)
{
  bCanClose=true;
  Close();
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::FormShow(TObject *Sender)
{
//  this->mnuShow->Caption="Hide";
  this->mnuShow->Visible=false;
  this->mnuHide->Visible=true;
  bMouseDown=false;
  this->Caption="StatPlus ... <http://coolsite.to/dllee> ... Yn]Yw";
}
//----------------------------------------------------------------------------////----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::BtnFontClick(TObject *Sender)
{
/*
  FontDialog->Font->Name=FontName;
  FontDialog->Font->Size=FontSize[0];
  if(FontDialog->Execute())
  {
    FontName=FontDialog->Font->Name;

    AnsiString asText;
    int iSize,iWidth,iHeight;

    Graphics::TBitmap *pBmp = new Graphics::TBitmap;
    pBmp->PixelFormat=pf8bit;
    pBmp->HandleType=bmDDB;
    pBmp->Height=16;
    pBmp->Width=16;
    pBmp->Canvas->Font->Name=FontName;

    asText="100";//%";
    FontSize[3]=4;
    for(int iSize=5;iSize<13;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[3]=iSize;
      else
        break;
    }

    asText="888";
    FontSize[2]=4;
    for(int iSize=5;iSize<13;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[2]=iSize;
      else
        break;
    }

    asText="88";
    FontSize[1]=5;
    for(int iSize=6;iSize<16;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[1]=iSize;
      else
        break;
    }
    asText="8";
    FontSize[0]=6;
    for(int iSize=7;iSize<18;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[0]=iSize;
      else
        break;
    }

    delete pBmp;
    TrayMessage(NIM_MODIFY);
  }
*/
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::CPUStatusMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if(Button==mbLeft)
  {
    bMouseDown=true;
    iDownX=X;
    iDownY=Y;
  }
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::CPUStatusMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  bMouseDown=false;
  // pG]ù~Ah۰ʲ^ӡC
  if(this->Top<0)this->Top=0;
  if(this->Left<0)this->Left=0;
  if((this->Top+this->Height) > Screen->Height) this->Top=Screen->Height-this->Height;
  if((this->Left+this->Width) > Screen->Width) this->Left=Screen->Width-this->Width;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::CPUStatusMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  iShowFadeCount=3;       // ]wwJ,X,ȤAs
                          //  Timer ˼ƨ 0 , ̳]wܦz
  iMovingInCount++;       // wJp
  if(iMovingInCount>=1)   // pGO~J
  {                       // hAz, HK˵ƭ
    ClearTransparent();
    iMovingInCount=-2000000000;   // Npƭܫܤp, ]wzu@
  }

  if(bMouseDown)
  {
    this->Left+=X-iDownX;
    this->Top+=Y-iDownY;
  }
}
//----------------------------------------------------------------------------//

//---------------------------------------------------------------------------
int __fastcall TFormStatPlus::GetCPUUsage(void)
{
  try
  {
    static PROCNTQSI NtQuerySystemInformation=NULL;
    static LARGE_INTEGER  m_liOldIdleTime;
    static LARGE_INTEGER  m_liOldSystemTime;

    if(iPlatformID==VER_PLATFORM_WIN32_NT)
    {
      static SYSTEM_BASIC_INFORMATION       m_SysBaseInfo;
      static SYSTEM_TIME_INFORMATION        SysTimeInfo;
      static SYSTEM_PERFORMANCE_INFORMATION SysPerfInfo;
      LONG                                  status;
      double                                dbIdleTime;
      bool                                  bFirstTime;

      bFirstTime=false;
      if(NtQuerySystemInformation==NULL)  // First Time initialize
      {
        NtQuerySystemInformation = (PROCNTQSI)GetProcAddress( GetModuleHandle("ntdll"), "NtQuerySystemInformation" );
        if(NtQuerySystemInformation==NULL)
          return 0;

        // get number of processors in the system
        NtQuerySystemInformation(SystemBasicInformation,&m_SysBaseInfo,sizeof(m_SysBaseInfo),NULL);

        // Initialise some variables
        m_liOldIdleTime.LowPart    = 0;
        m_liOldIdleTime.HighPart   = 0;
        m_liOldSystemTime.LowPart  = 0;
        m_liOldSystemTime.HighPart = 0;
        bFirstTime=true;
      }

      // CPU first
      // get new system time
      status = NtQuerySystemInformation(SystemTimeInformation,&SysTimeInfo,sizeof(SysTimeInfo),0);
      if (status!=NO_ERROR)
        return 0;

      // get new CPU's idle time
      status = NtQuerySystemInformation(SystemPerformanceInformation,&SysPerfInfo,sizeof(SysPerfInfo),NULL);
      if (status != NO_ERROR)
        return 0;

      // if it's a first call       - skip it
      if (bFirstTime)
        return 0;

      double dbSystemTime;

      // CurrentValue = NewValue - OldValue
      dbIdleTime   = Li2Double(SysPerfInfo.liIdleTime) - Li2Double(m_liOldIdleTime);
      dbSystemTime = Li2Double(SysTimeInfo.liKeSystemTime) - Li2Double(m_liOldSystemTime);

      // CurrentCpuIdle = IdleTime / SystemTime
      dbIdleTime = dbIdleTime / dbSystemTime;

      // CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors
      dbIdleTime = 100.0 - dbIdleTime * 100.0 / (double)m_SysBaseInfo.bKeNumberProcessors + 0.5;

      // store new CPU's idle       and system time
      m_liOldIdleTime       = SysPerfInfo.liIdleTime;
      m_liOldSystemTime     = SysTimeInfo.liKeSystemTime;

      return (int)dbIdleTime;

//// ntdll!NtQuerySystemInformation (NT specific!)
////
//// The function       copies the system information of the
//// specified type into a buffer
////
//// NTSYSAPI
//// NTSTATUS
//// NTAPI
//// NtQuerySystemInformation(IN  UINT    SystemInformationClass,   // information type
////                          OUT PVOID   SystemInformation,        // pointer to buffer
////                          IN  ULONG   SystemInformationLength,  // buffer size in bytes
////                          OUT PULONG  ReturnLength OPTIONAL );  // pointer to a 32-bit
////                                                                // variable that receives
////                                                                // the number of bytes
////                                                                // written to the buffer
////
    }
    else if(iPlatformID==VER_PLATFORM_WIN32_WINDOWS)
    {
      static  DWORD dwCpuUsage=2002;
      HKEY    hkey;
      DWORD   dwDataSize;
      DWORD   dwType;

      if(__bStopGetCPUUsage)
      {
        // stoping the counter
        if ( RegOpenKeyEx( HKEY_DYN_DATA,"PerfStats\\StopStat",0,KEY_ALL_ACCESS,&hkey ) != ERROR_SUCCESS)
          return 0;
        dwDataSize = sizeof(DWORD);
        RegQueryValueEx( hkey,"KERNEL\\CPUUsage",NULL,&dwType,(LPBYTE)&dwCpuUsage,&dwDataSize );
        RegCloseKey(hkey);
        return 0;
      }

      if(dwCpuUsage==2002)  // Starting the counter
      {
        if (RegOpenKeyEx( HKEY_DYN_DATA,"PerfStats\\StartStat",0,KEY_ALL_ACCESS,&hkey)!= ERROR_SUCCESS)
          return 0;
        dwDataSize = sizeof(DWORD);
        RegQueryValueEx(hkey,"KERNEL\\CPUUsage",NULL,&dwType,(LPBYTE)&dwCpuUsage,&dwDataSize);
        RegCloseKey(hkey);
      }

      // geting current counter's value
      if ( RegOpenKeyEx( HKEY_DYN_DATA,"PerfStats\\StatData",0,KEY_READ,&hkey) != ERROR_SUCCESS)
        return 0;

      dwDataSize = sizeof(DWORD);
      RegQueryValueEx( hkey,"KERNEL\\CPUUsage",NULL,&dwType,(LPBYTE)&dwCpuUsage,&dwDataSize );
      RegCloseKey(hkey);

      return (int) dwCpuUsage;
    }
  }
  catch(...)// You should always catch by reference.
  {
    return 0;
  }
  return 0;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


void __fastcall TFormStatPlus::mnuTaskMsgClick(TObject *Sender)
{
  char szDir[MAX_PATH+1];
  GetSystemDirectory(szDir, MAX_PATH);
  ShellExecute(Application->Handle, "open", "taskmgr.exe", "", szDir, SW_SHOWNORMAL);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuBatMsgClick(TObject *Sender)
{
  char szDir[256];
  GetSystemDirectory(szDir, MAX_PATH);
  ShellExecute(Application->Handle, "open", "rundll32.exe", "shell32.dll,Control_RunDLL powercfg.cpl", szDir, SW_SHOWNORMAL);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuShowClick(TObject *Sender)
{
//  if(this->Visible)
//    Hide();
//  else
//  {
    Show();
      if(!mnuOnTop->Checked)  // w]w OnTopAhA OnTop
      {                       // _h OnTopAA OnTop
        SetTopMost();
        ClearTopMost();
      }
//  }
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::mnuHideClick(TObject *Sender)
{
    Hide();
}
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::CPUStatusDblClick(TObject *Sender)
{
  Hide();
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::FormHide(TObject *Sender)
{
//  this->mnuShow->Caption="Show";
  bMouseDown=false;
  this->mnuShow->Visible=true;
  this->mnuHide->Visible=false;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::FormCreate(TObject *Sender)
{
//  this->Left=Screen->Width-this->Width;
//  this->Top=0;

    TRegistry *Reg = new TRegistry;
    try
    {
      Reg->RootKey=HKEY_CURRENT_USER;
      if(Reg->OpenKey("\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", true))
      {
        mnuAutoRun->Checked=Reg->ValueExists("StatPlus");
        Reg->CloseKey();
      }
    }
    __finally
    {
      delete Reg;
    }

    HotKeyRegisteredString=EmptyStr;
    HotKeyList->Clear();
    int iKeyCode=SelectKeyCode("F2");
    for(int i=2;i<=12;i++,iKeyCode++)
    {
      if(HotKeyWinF[i].Length()==0) continue;

      HotKeyID[i]=0x4000+iKeyCode;
      if( RegisterHotKey(
              this->Handle,  // window to receive hot-key notification
              HotKeyID[i],   // identifier of hot key
              MOD_WIN,       // key-modifier flags
              iKeyCode       // virtual-key code
              )==true)
      {
        HotKeyRegistered[i]=true;
        HotKeyList->Add("Win + F"+IntToStr(i)+" : "+HotKeyWinF[i]);
      }
    }
    if(HotKeyList->Count>0)
    {
      HotKeyRegisteredString="StatPlus registered following HotKey:\n\n";
      for(int i=0;i<HotKeyList->Count;i++)
        HotKeyRegisteredString=HotKeyRegisteredString+HotKeyList->Strings[i]+"\n";
      // ShowMessage(HotKeyRegisteredString);
    }

  // ϥ TDateTime  DayOfWeek(),  1:Sun, 2:Mon, ..., 7:Sat
  asWeekDay[1]="()";
  asWeekDay[2]="(@)";
  asWeekDay[3]="(G)";
  asWeekDay[4]="(T)";
  asWeekDay[5]="(|)";
  asWeekDay[6]="()";
  asWeekDay[0]="()";

//   mnuFade->Checked=true;
//   SetTransparent(200);

/*--------------------------------------------------------------
    char buffer[1024];
    GetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_IFIRSTDAYOFWEEK,buffer,1023);
    ShowMessage(AnsiString(buffer));

    // HU]wL!!(Lk]J)
    bool b;
    b=SetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SABBREVDAYNAME1,"@");
    b=SetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SABBREVDAYNAME2,"G");
    b=SetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SABBREVDAYNAME3,"T");
    b=SetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SABBREVDAYNAME4,"|");
    b=SetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SABBREVDAYNAME5,"");
    b=SetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SABBREVDAYNAME6,"");
    b=SetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SABBREVDAYNAME7,"");

    AnsiString a;
    for(int i=0;i<7;i++)
      a=a+ShortDayNames[i]+", ";
    a=a+"\n";
    for(int i=0;i<7;i++)
      a=a+LongDayNames[i]+", ";
    ShowMessage(a);
-------------------------------------------------------*/

/* L!! tη|۰ʧ^,DhקtΪ]w
  ShortDayNames[0]="()";
  ShortDayNames[1]="(@)";
  ShortDayNames[2]="(G)";
  ShortDayNames[3]="(T)";
  ShortDayNames[4]="(|)";
  ShortDayNames[5]="()";
  ShortDayNames[6]="()";
*/
/*
                        if(!(uKeyMod & MOD_SHIFT)){
                                strcpy(szNewVal, "SHIFT");
                        } else if(!(uKeyMod & MOD_ALT)){
                                strcpy(szNewVal, "ALT");
                        } else if(!(uKeyMod & MOD_CONTROL)){
                                strcpy(szNewVal, "CTRL");
                        } else if(!(uKeyMod & MOD_WIN)){
                                strcpy(szNewVal, "WIN");
                        }


        if(strstr(_strupr(szValue), "WIN") != NULL)
        {       dbgTrace("Hotkey modifier includes WIN");
                uKeyMod = uKeyMod | MOD_WIN;
        }

        if(strstr(_strupr(szValue), "CTRL") != NULL)
        {       dbgTrace("Hotkey modifier includes CTRL");
                uKeyMod = uKeyMod | MOD_CONTROL;
        }

        if(strstr(_strupr(szValue), "SHIFT") != 0)
        {       dbgTrace("Hotkey modifier includes SHIFT");
                uKeyMod = uKeyMod | MOD_SHIFT;
        }

        if(strstr(_strupr(szValue), "ALT") != 0)
        {       dbgTrace("Hotkey modifier includes ALT");
                uKeyMod = uKeyMod | MOD_ALT;
        }

*/
/*
        // ʺAJUser32.dll
        hDllInst=LoadLibrary("user32.dll");
        if (hDllInst==NULL)
        {
          ShowMessage("User32.Dll Library Open Fail!");
          return;
        }
        // SetLayeredWindowAttributes functionEntry
        SETLAYER *SetLayeredWindowAttributes;
        SetLayeredWindowAttributes =(SETLAYER *)GetProcAddress( hDllInst, "SetLayeredWindowAttributes");
        if (SetLayeredWindowAttributes == NULL)
        {
          ShowMessage("SetLayeredWindowAttributes Set Error!");
        }

        // ]wXRAWindow
        long lStyle;
        lStyle=GetWindowLong(Handle, GWL_EXSTYLE );
        lStyle |= 0x00080000;
        SetWindowLong(Handle, GWL_EXSTYLE, lStyle );

        // ]wbz, Ѽ3: 0=z , 255z
        SetLayeredWindowAttributes(Handle, 0, 155, 2);

        // ʺAUser32.dll
        FreeLibrary(hDllInst);
*/
}
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAutoRunClick(TObject *Sender)
{
    TRegistry *Reg = new TRegistry;
    try
    {
      if(Reg->OpenKey("\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", true))
      {
        if(Reg->ValueExists("StatPlus")) // pGwgsbAhR
        {
          mnuAutoRun->Checked=false;
          Reg->DeleteValue("StatPlus");
        }
        else
        {
          char ShortPath[513];
          GetShortPathName(Application->ExeName.c_str(),ShortPath,512);
          Reg->WriteString("StatPlus",AnsiString(ShortPath));
          mnuAutoRun->Checked=true;
        }
        Reg->CloseKey();
      }
    }
    __finally
    {
      delete Reg;
    }
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuOnTopClick(TObject *Sender)
{
  mnuOnTop->Checked=!mnuOnTop->Checked;
  if(mnuOnTop->Checked)
    //  this->FormStyle=fsStayOnTop;
    SetTopMost();
  else
    //  this->FormStyle=fsNormal;
    ClearTopMost();
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuShowKeysClick(TObject *Sender)
{
  if(HotKeyRegisteredString.Length()>0)
  {
    // ShowMessage(HotKeyRegisteredString);
    MessageBox(this->Handle,HotKeyRegisteredString.c_str(),"StatPlus HotKey List",
                MB_OK|MB_ICONINFORMATION|MB_TASKMODAL|MB_SETFOREGROUND);
  }
  else
  {
    // ShowMessage("No Hot Keys");
    MessageBox(this->Handle,"No Any Hot Keys defined.\n\n"
                "You can define your HotKeys(Win+Fn) at\n\n"
                "[HKEY_CURRENT_USER\\Software\\StatPlus]\n"
                "F2=**ShowTrigger**\n"
                "F10=explorer.exe\n"
                "F11=regedit.exe\n"
                "F12=calc.exe\n\n"
                ,"StatPlus HotKey List",
                MB_OK|MB_ICONQUESTION|MB_TASKMODAL|MB_SETFOREGROUND);
  }
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::SetTopMost(void)
{
  // DWORD dwExStyle = GetWindowLong(Application->Handle, GWL_EXSTYLE);
  // dwExStyle |= WS_EX_TOPMOST;
  // SetWindowLong(Application->Handle, GWL_EXSTYLE, dwExStyle);

  SetWindowPos(Application->Handle, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::ClearTopMost(void)
{

  // DWORD dwExStyle = GetWindowLong(Application->Handle, GWL_EXSTYLE);
  // dwExStyle &= (~WS_EX_TOPMOST);
  // SetWindowLong(Application->Handle, GWL_EXSTYLE, dwExStyle);

  SetWindowPos(Application->Handle, HWND_NOTOPMOST, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuScreenSaveClick(TObject *Sender)
{
  SendMessage(HWND_BROADCAST,WM_SYSCOMMAND,SC_SCREENSAVE,0);
}
//----------------------------------------------------------------------------//
// ]wbz, Ѽ3: 0=z , 255z
void __fastcall TFormStatPlus::SetTransparent(int Value)
{
  if(bEnableFade==false) return;  // Win98 ^I
//  DWORD dwExStyle;
//      HINSTANCE       hLib;
//      if (hLib = LoadLibrary("user32.dll"))
//      {
//              PFNSetLayeredWindowAttributes pSLWA;
//
//              if (pSLWA = (PFNSetLayeredWindowAttributes)GetProcAddress(hLib, "SetLayeredWindowAttributes"))
//              {
//                      dwExStyle = GetWindowLong(Application->Handle, GWL_EXSTYLE);
//      dwExStyle |= WS_EX_LAYERED;
//      // Add WS_EX_LAYERED to this window's styles
//      SetWindowLong(Application->Handle, GWL_EXSTYLE, dwExStyle);
//      // Apply alpha level
//      pSLWA (Application->Handle, clBtnFace, 128, LWA_COLORKEY);
//
//              }
//    FreeLibrary(hLib);
//      }
        // ʺAJUser32.dll
        hDllInst=LoadLibrary("user32.dll");
        if (hDllInst==NULL)
        {
          ShowMessage("User32.Dll Library Open Fail!");
          return;
        }
        // SetLayeredWindowAttributes functionEntry
        SETLAYER *SetLayeredWindowAttributes;
        SetLayeredWindowAttributes =(SETLAYER *)GetProcAddress( hDllInst, "SetLayeredWindowAttributes");
        if (SetLayeredWindowAttributes == NULL)
        {
          ShowMessage("SetLayeredWindowAttributes Set Error!");
        }

        // ]wXRAWindow
        long lStyle;
        lStyle=GetWindowLong(Handle, GWL_EXSTYLE );
        lStyle |= 0x00080000;
        SetWindowLong(Handle, GWL_EXSTYLE, lStyle );

        // ]wbz, Ѽ3: 0=z , 255z
        SetLayeredWindowAttributes(Handle, 0, Value, 2);

        // ʺAUser32.dll
        FreeLibrary(hDllInst);
}
//----------------------------------------------------------------------------//
void __fastcall TFormStatPlus::ClearTransparent(void)
{
  if(bEnableFade==false) return;  // Win98 ^I
//  DWORD dwExStyle;
//  dwExStyle = GetWindowLong(Application->Handle, GWL_EXSTYLE);
//  dwExStyle &= (~WS_EX_LAYERED);
//  SetWindowLong(Application->Handle, GWL_EXSTYLE, dwExStyle);

        // ʺAJUser32.dll
        hDllInst=LoadLibrary("user32.dll");
        if (hDllInst==NULL)
        {
          ShowMessage("User32.Dll Library Open Fail!");
          return;
        }
        // SetLayeredWindowAttributes functionEntry
        SETLAYER *SetLayeredWindowAttributes;
        SetLayeredWindowAttributes =(SETLAYER *)GetProcAddress( hDllInst, "SetLayeredWindowAttributes");
        if (SetLayeredWindowAttributes == NULL)
        {
          ShowMessage("SetLayeredWindowAttributes Set Error!");
        }

        // ]wXRAWindow
        long lStyle;
        lStyle=GetWindowLong(Handle, GWL_EXSTYLE );
        lStyle |= 0x00080000;
        SetWindowLong(Handle, GWL_EXSTYLE, lStyle );

        // ]wbz, Ѽ3: 0=z , 255z
        SetLayeredWindowAttributes(Handle, 0, 255, 2);

        // ʺAUser32.dll
        FreeLibrary(hDllInst);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuFadeClick(TObject *Sender)
{
  if(bEnableFade==false) return;

  mnuFade->Checked=!mnuFade->Checked;
  if(mnuFade->Checked)
    //  this->FormStyle=fsStayOnTop;
    SetTransparent(200);
  else
    //  this->FormStyle=fsNormal;
    ClearTransparent();
}
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAuto1MinClick(TObject *Sender)
{
        mnuAuto1Min->Checked=true;
        iAutoFreeInterval=60;
        AutoFreeTimeIndex=1;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAuto5MinClick(TObject *Sender)
{
        mnuAuto5Min->Checked=true;
        iAutoFreeInterval=60*5;
        AutoFreeTimeIndex=2;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAuto10MinClick(TObject *Sender)
{
        mnuAuto10Min->Checked=true;
        iAutoFreeInterval=60*10;
        AutoFreeTimeIndex=3;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAuto16MBClick(TObject *Sender)
{
        mnuAuto16MB->Checked=true;
        iAutoFreeSize=16;
        bAutoFreeMoreMem=false;
        AutoFreeMBIndex=1;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAuto32MBClick(TObject *Sender)
{
        mnuAuto32MB->Checked=true;
        iAutoFreeSize=32;
        bAutoFreeMoreMem=false;
        AutoFreeMBIndex=2;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAuto64MBClick(TObject *Sender)
{
        mnuAuto64MB->Checked=true;
        iAutoFreeSize=64;
        bAutoFreeMoreMem=false;
        AutoFreeMBIndex=3;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAuto128MBClick(TObject *Sender)
{
        mnuAuto128MB->Checked=true;
        iAutoFreeSize=128;
        bAutoFreeMoreMem=false;
        AutoFreeMBIndex=4;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAutoMore4MBClick(TObject *Sender)
{
        mnuAutoMore4MB->Checked=true;
        iAutoFreeSize=4;
        bAutoFreeMoreMem=true;
        AutoFreeMBIndex=5;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAutoMore8MBClick(TObject *Sender)
{
        mnuAutoMore8MB->Checked=true;
        iAutoFreeSize=8;
        bAutoFreeMoreMem=true;
        AutoFreeMBIndex=6;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAutoMore16MBClick(TObject *Sender)
{
        mnuAutoMore16MB->Checked=true;
        iAutoFreeSize=16;
        bAutoFreeMoreMem=true;
        AutoFreeMBIndex=7;
}
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuAutoTriggerClick(TObject *Sender)
{
    mnuAutoFree->Checked=!mnuAutoFree->Checked;
    mnuAutoTrigger->Checked=mnuAutoFree->Checked;
    bAutoFreeMem=mnuAutoFree->Checked;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuFree64MBClick(TObject *Sender)
{
  FreeMemory(64);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuFree128MBClick(TObject *Sender)
{
  FreeMemory(128);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuFree256MBClick(TObject *Sender)
{
  FreeMemory(256);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuMore16MBClick(TObject *Sender)
{
  FreeMemory((MemoryStatus.dwAvailPhys>>20)+16);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuMore32MBClick(TObject *Sender)
{
  FreeMemory((MemoryStatus.dwAvailPhys>>20)+32);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuMore64MBClick(TObject *Sender)
{
  FreeMemory((MemoryStatus.dwAvailPhys>>20)+64);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuSaveClick(TObject *Sender)
{
  SaveRegIniSetting();
  TrayMessage(NIM_MODIFY);
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuReloadSettingClick(TObject *Sender)
{
  LoadRegIniSetting();
  TrayMessage(NIM_MODIFY);
}
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuFontClick(TObject *Sender)
{
  FontDialog->Font->Name=FontName;
  FontDialog->Font->Size=FontSize[0];
  if(FontDialog->Execute())
  {
    FontName=FontDialog->Font->Name;

    AnsiString asText;
    int iSize,iWidth,iHeight;

    Graphics::TBitmap *pBmp = new Graphics::TBitmap;
    pBmp->PixelFormat=pf8bit;
    pBmp->HandleType=bmDDB;
    pBmp->Height=16;
    pBmp->Width=16;
    pBmp->Canvas->Font->Name=FontName;

    asText="100";//%";
    FontSize[3]=4;
    for(int iSize=5;iSize<13;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[3]=iSize;
      else
        break;
    }

    asText="888";
    FontSize[2]=4;
    for(int iSize=5;iSize<13;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[2]=iSize;
      else
        break;
    }

    asText="88";
    FontSize[1]=5;
    for(int iSize=6;iSize<16;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[1]=iSize;
      else
        break;
    }
    asText="8";
    FontSize[0]=6;
    for(int iSize=7;iSize<18;iSize++)
    {
      pBmp->Canvas->Font->Size=iSize;
      iWidth=pBmp->Canvas->TextWidth(asText);
      iHeight=pBmp->Canvas->TextHeight(asText);
      if(iWidth<=16 && iHeight<=16)
        FontSize[0]=iSize;
      else
        break;
    }

    delete pBmp;
    TrayMessage(NIM_MODIFY);
  }
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuTrayCPUClick(TObject *Sender)
{
    TrayIconIndex=1;
    mnuTrayCPU->Checked=true;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuTrayMEMClick(TObject *Sender)
{
    TrayIconIndex=2;
    mnuTrayMEM->Checked=true;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuTrayBATClick(TObject *Sender)
{
    TrayIconIndex=3;
    mnuTrayBAT->Checked=true;
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuColorClick(TObject *Sender)
{
  ColorDialog->Color=cTrayIconColor;
  if(ColorDialog->Execute())
  {
    cTrayIconColor=ColorDialog->Color;
    TrayMessage(NIM_MODIFY);
  }
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuBatteryInfoClick(TObject *Sender)
{
    EnableBatteryInfo=!EnableBatteryInfo;
    if(EnableBatteryInfo)
    {
      mnuBatteryInfo->Checked=true;
      BATStatus->Visible=true;
      mnuBatMsg->Visible=true;
      mnuTrayBAT->Visible=true;
    }
    else
    {
      mnuBatteryInfo->Checked=false;
      BATStatus->Visible=false;
      mnuBatMsg->Visible=false;
      mnuTrayBAT->Visible=false;
    }
    UpdateAllStatus();
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuSwapInfoClick(TObject *Sender)
{
    EnableSwapInfo=!EnableSwapInfo;
    if(EnableSwapInfo)  //  Swap Info
    {
      mnuSwapInfo->Checked=true;
      SWPStatus->Visible=true;
    }
    else
    {
      mnuSwapInfo->Checked=false;
      SWPStatus->Visible=false;
    }

    UpdateAllStatus();
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::mnuMemInfoClick(TObject *Sender)
{
    EnableMemInfo=!EnableMemInfo;
    if(EnableMemInfo)  //  Mem Info
    {
      mnuMemInfo->Checked=true;
      MEMStatus->Visible=true;
    }
    else
    {
      mnuMemInfo->Checked=false;
      MEMStatus->Visible=false;
    }
    UpdateAllStatus();
}
//----------------------------------------------------------------------------//

void __fastcall TFormStatPlus::UpdateAllStatus(void)
{
    if(EnableMemInfo)  //  Mem Info
    {
      if(EnableSwapInfo)  //  Swap Info
      {
        if(EnableBatteryInfo)
        {
          this->Panel1->Height=CPUStatus->Height*4+2;
          this->ClientHeight=this->Panel1->Height;
        }
        else
        {
          this->Panel1->Height=CPUStatus->Height*3+2;
          this->ClientHeight=this->Panel1->Height;
        }
      }
      else
      {
        this->Panel1->Height=CPUStatus->Height*2+2;
        this->ClientHeight=this->Panel1->Height;
      }
    }
    else
    {
      this->Panel1->Height=CPUStatus->Height*1+2;
      this->ClientHeight=this->Panel1->Height;
    }
}
//----------------------------------------------------------------------------//

